//EagleB3 v.1.9.1.b
//dollop v.1.9.1.b+
//     MSV v.1.9.1
//    (MSV v.1.9.1)    Eagle_version.txt
//
//   CVAVR  BODEN  BODLEVEL  (=,   =0).
//     (= ,   =1).
//.   Notes.txt  Coder.txt

//#define NoCheckThrottleOnStart //,          

//#define AntennaCtrlUse  //,     
    #ifdef AntennaCtrlUse
    #endif

#include <mega128.h>
#include <delay.h>
#include <stdio.h>
#include <math.h>
//#include <i2c.h>  -   TWI
#include "def.h"
#include "LCD_3320.h"
#include "menu.h"
#include "displ.h"
#include "coder.h"

/*
// I2C Bus functions  -   TWI
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=5
   .equ __scl_bit=4
#endasm
*/

//    EEPROM'
eeprom MODEL_SET EEPR_models[MAX_MODELS];
eeprom unsigned char EEPR_start_model;
eeprom unsigned char EEPR_f_sound_en;
eeprom unsigned char EEPR_BatCntr[3];
eeprom unsigned char EEPR_AntCntr;
eeprom int EEPR_ADmid[5], EEPR_ADmax[5], EEPR_ADmin[5];
eeprom unsigned char EEPR_FirstON, EEPR_Calibration;
eeprom signed int EPPR_CalibrTemperature[2];
//------------------------------------------------------
signed int out_control[MAX_CONTRS];
signed int ADmid[6];
signed int ADmin[6];
signed int ADmax[6];
signed int ADcur[6];
signed int out_ch[MAX_CHANS];
MODEL_SET cur_model;
unsigned char cur_model_ind;
unsigned char cur_mode_ind;
bit f_TCut;
unsigned int cur_Batt;
#ifdef AntennaCtrlUse
    unsigned int cur_Power;
    unsigned int cur_Antenna;
#endif
unsigned int cur_Temperature;
signed int dir_Temperature;
unsigned char wd_Temperature;
unsigned int div_trimmer;
unsigned char f_l;
unsigned char g_MainMenuMode;
extern bit f_timer_en;
unsigned int gRPMtmp=0;
unsigned int gRPM[SIZE_RPM_BUFF];
unsigned char gRPMn;
signed int g_pos_d[3];
unsigned char g_keys;
signed int gAddPropVal;
signed int gAddPropValOld;
bit gfca_start;

#define F_SW1 1
#define F_SW2_1 2
#define F_SW2_2 4
#define F_SW3 8
#define F_DUAL1 0x10
#define F_DUAL2 0x20
#define F_DUAL3 0x40
#define F_TCUT 0x80

#define UNI_KEY 0x5a
//------------------------------------------------------
//------------------------------------------------------
#define ADC_VREF_TYPE 0x00
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
delay_us(10);
ADCSRA|=0x40; // Start the AD conversion
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10; // Stop
return ADCW;
}
//------------------------------------------------------
//------------------------------------------------------
// (PD2-tachometr)
interrupt [EXT_INT2] void ext_int2_isr(void)
{
gRPMtmp++;
if(gRPMtmp==1024) EIMSK&=0xdf; // EIMSK&=0xfe;  -    INT0
}
//------------------------------------------------------
void TimerTachometer(void)
{ // 50Hz
static unsigned char div;
div++;
if(div>=25)
  { // ~2Hz
  div=0;
  gRPM[gRPMn]=gRPMtmp;
  if(++gRPMn>=SIZE_RPM_BUFF) gRPMn=0;
  gRPMtmp=0;
  }
}
//------------------------------------------------------
//------------------------------------------------------
__flash const unsigned int notes[]= {//Note A 1-okt;
440, 466, 494, 523,    554,  588,  612,  660,    698,  740,  784,  830,
880, 932, 988, 1064,   1108, 1176, 1224, 1320,   1396, 1480, 1568, 1660};
BEEP_TRACK_DEF flash *beep_track;
unsigned int beep_length;
unsigned char beep_cnt;
unsigned char beep_cntn;
unsigned char beep_rep;
bit f_beep_timer;
bit f_beep_EEP;
bit f_beep_key;
bit f_beep_trimmer;
bit f_beep_trimmer_c;

extern flash const BEEP_TRACK_DEF hello_sound[];
//------------------------------------------------------
void beep(BEEP_TRACK_DEF flash *note)
{
unsigned long ln, freq;
unsigned int v;

freq=notes[note->note];
v=(unsigned int)((1500000L/2)/freq);
ICR3H=(unsigned char)(v>>8);
ICR3L=(unsigned char)v;
ln=note->ms*freq;
beep_length=ln/1000;
}
//------------------------------------------------------
// Timer 3 output compare A interrupt service routine
interrupt [TIM3_COMPA] void timer3_compa_isr(void)
{
bit f_con;

if(PINE.3) return;
if(--beep_length==0)
  {
  f_con=0;
  if(++beep_cntn<beep_cnt)  f_con=1;
  else if(beep_rep) { beep_rep--; beep_cntn=0; f_con=1; }
  if(f_con==0) { TCCR3B&=0xf8; return; }  // stop
  else beep((beep_track+beep_cntn));
  }
}
//------------------------------------------------------
void beep_start(BEEP_TRACK_DEF flash *notes, unsigned char cnt, unsigned char rep)
{
beep_track=notes;
beep_cnt=cnt;
beep_cntn=0;
beep_rep=rep;
beep(notes);
TCCR3B|=0x2;
}
//-------------------------------------------------------------
//-------------------------------------------------------------
//-------------------------------------------------------------
unsigned int CHcalc (char ch_ind)
{
signed long ln;
unsigned char i;
signed char *mix;
CHANNEL * channel;
signed int v, val;

mix=cur_model.modes[cur_mode_ind].mixer[ch_ind];
val=0;
for (i=0; i<MAX_CONTRS; i++)
  {
  if(mix[i])
    {
    ln=out_control[i]; ln*=mix[i]; ln/=100;
    val+=(signed int)ln;
    }
  }
channel=&cur_model.channels[ch_ind];
v=channel->subtrimmer; v*=5; //50*5 -> +-250
val+=v;
//limit
if(val<-900) val=-900;
if(val>900) val=900;
//--------------------------------
//#define EPA_MODE1
#ifdef EPA_MODE1
//epa 1 (     epa)
v=-channel->epa[0]; v*=90; v/=12;
if(val<v) val=v;
v=channel->epa[1]; v*=90; v/=12;
if(val>v) val=v;
#else
#ifdef EPA_MODE2
//epa 2 (    epa-<>0  0<>epa+)
ln=val;
if(val<0) ln*=channel->epa[0];
else ln*=channel->epa[1];
val=(signed int)(ln/120);
#else
//epa 3 (  epa-<>epa+   )
ln=channel->epa[0]; ln+=channel->epa[1]; ln*=val;
val=(signed int)(ln/240);
v=channel->epa[1]; v-=channel->epa[0]; v*=90; v/=24;
val+=v;
#endif
#endif
//----------------------------------
val*=(signed int)channel->reverse;
val+=2250; // 1,5 ms
return (unsigned int)val;
}
//-------------------------------------------------------------
signed int interpol(signed int val, signed char* nodes )
{
unsigned char n;
signed int n1, n2, vmin;
signed long ln;

ln=val; ln*=6; n=ln/1500;
n1=*(nodes+n); n1=(n1*75)/10;
n2=*(nodes+n+1); n2=(n2*75)/10;
vmin=n; vmin*=250;
ln=(val-vmin); ln*=(n2-n1); ln/=250;
return ln + n1;
}
//-------------------------------------------------------------
signed int rate_calc(signed int val, unsigned char min, unsigned char max)
{
unsigned char rate;
signed long v;

if(val<0) rate=min;
else rate=max;
v=val; v*=rate; v/=100;
return v;
}
//-------------------------------------------------------------
unsigned char ReadKeys(void)
{
unsigned char f;

f=0;
if(!SW1) f|=F_SW1;
if(!SW2_1) f|=F_SW2_1;
if(!SW2_2) f|=F_SW2_2;
if(!SW3) f|=F_SW3;
if(!DUAL_ail) f|=F_DUAL1;
if(!DUAL_elev) f|=F_DUAL2;
if(!DUAL_rud) f|=F_DUAL3;
if(!Tcut_KEY) f|=F_TCUT;
return f;
}
//-------------------------------------------------------------
void Calc (void)
{ // 50Hz (20ms)
static unsigned char div_trim;
signed char *trim;
signed int input[10];
unsigned int i, n;
signed long vl;
const unsigned char acntr[]={ ch_Ailerons, ch_Elevator, ch_Throttle, ch_Rudder, ch_Rpop_contr };
signed int vi;
unsigned char mn, mx;
DEF_MODE *mode;
unsigned char f_dual[3];
unsigned char keys;
unsigned char f;

//  
if(!MODE_KEY2)           i=0;
else if(!MODE_KEY1)      i=2;
else                     i=1;
if(cur_mode_ind!=i) { BEEP; save_trimmer(); cur_mode_ind=i; }

// 
trim=cur_model.modes[cur_mode_ind].trimmers;
if (div_trim)
  {
  f=0;
  if(!trim_0up && trim[0]<80) { trim[0]++; f|=1;  }
  if(!trim_0down && trim[0]>-80) { trim[0]--;  f|=1; }
  if(!trim_1up && trim[1]<80) { trim[1]++; f|=2; }
  if(!trim_1down && trim[1]>-80) { trim[1]--; f|=2; }
  if(!trim_2up && trim[2]<80) { trim[2]++;   f|=4; }
  if(!trim_2down && trim[2]>-80) { trim[2]--; f|=4; }
  if(!trim_3up && trim[3]<80) { trim[3]++; f|=8; }
  if(!trim_3down && trim[3]>-80) { trim[3]--; f|=8; }
  if((f & 1) && trim[0]==0) f_beep_trimmer_c=1;
  if((f & 2) && trim[1]==0) f_beep_trimmer_c=1;
  if((f & 4) && trim[2]==0) f_beep_trimmer_c=1;
  if((f & 8) && trim[3]==0) f_beep_trimmer_c=1;
  if(f)
    {
    div_trimmer=1500;
    if(f_beep_trimmer_c==0) f_beep_trimmer=1;
    }
  }
div_trim=!div_trim;

mode=&cur_model.modes[cur_mode_ind];
//  
for(i=0; i<5; i++)
  {
  n=i; if(i==4) n=7;
  vl=read_adc(acntr[i]);
  if(vl<ADmid[i])
    {
    if(ADmin[i]>vl) ADmin[i]=vl;
    vl-=ADmin[i]; vl*=750; input[n]=vl/(ADmid[i]-ADmin[i]);
    }
  else
    {
    if(ADmax[i]<vl) ADmax[i]=vl;
    vl-=ADmid[i]; vl*=750; input[n]=750+(vl/(ADmax[i]-ADmid[i]));
    }
  }
gAddPropVal=input[7];
keys=ReadKeys(); if(keys!=g_keys) { BEEP; g_keys=keys; }
if(keys & F_SW1) input[4]=0; else input[4]=1500;
if(keys & F_SW2_1) input[5]=0;
else if(keys & F_SW2_2) input[5]=1500;
else input[5]=750;
if(keys & F_SW3) input[6]=0; else input[6]=1500;
for(i=0; i<3; i++)
  {
  vi=mode->contr_d[i].delay;
  if(vi==0) g_pos_d[i]=input[4+i];
  else if(g_pos_d[i]!=input[4+i])
    {
    vl=g_pos_d[i]; vl*=vi; vl/=(300/2); vl++; vl/=2;
    if(g_pos_d[i]<input[4+i])
      {
      vl++; vl*=(300*2); vl/=vi; vl++; vl/=2;
      if(vl>input[4+i]) vl=input[4+i];
      }
    else
      {
      vl--; vl*=(300*2); vl/=vi; vl++; vl/=2;
      if(vl<input[4+i]) vl=input[4+i];
      }
    g_pos_d[i]=vl;
    input[4+i]=vl;
    }
  }
input[8]=input[mode->contr_v[0].from];
input[9]=input[mode->contr_v[1].from];
//   
if (keys & F_TCUT) f_TCut=1; else f_TCut=0;
//  
f_dual[0]=(keys & F_DUAL1);
f_dual[1]=(keys & F_DUAL2);
f_dual[2]=(keys & F_DUAL3);
//  
for(i=0; i<3; i++)
  {
  n=i; if(i==2) n++;
  vi=interpol(input[n], mode->contr_ab[i].cur_nodes+1);
  if(f_dual[i]) { mn=mode->contr_ab[i].minDRates; mx=mode->contr_ab[i].maxDRates; }
  else { mn=mode->contr_ab[i].minRates; mx=mode->contr_ab[i].maxRates; }
  out_control[n]=rate_calc(vi, mn, mx);
  vi=mode->trimmers[n]; vi*=5; out_control[n]+=vi;
  }
if(f_TCut) { vi=mode->contr_tr.tcut; vi*=-75; out_control[2]=vi/10; }
else
  {
  vi=interpol(input[2], mode->contr_tr.cur_nodes+1);
  out_control[2]=rate_calc(vi, mode->contr_tr.minRates, mode->contr_tr.maxRates);
  vi=mode->trimmers[2]; vi*=5; out_control[2]+=vi;
  }
if(cur_model.timer_mode==2) { if(!f_TCut && input[2]>150) f_timer_en=1; else f_timer_en=0; }

for(i=0; i<3; i++)
  {
  vi=input[4+i]-750;
  out_control[4+i]=rate_calc(vi, mode->contr_d[i].minRates, mode->contr_d[i].maxRates);
  }

vi=interpol(input[7], mode->contr_ap.cur_nodes+1);
out_control[7]=rate_calc(vi, mode->contr_ap.minRates, mode->contr_ap.maxRates);

for(i=0; i<2; i++)
  {
  vi=interpol(input[8+i], mode->contr_v[i].cur_nodes+1);
  out_control[8+i]=rate_calc(vi, mode->contr_v[i].minRates, mode->contr_v[i].maxRates);
  }
}
//------------------------------------------------------

interrupt [TIM1_COMPA] void timer1_compa_isr(void) {
    //         ,
    // ..      ,        .
    // "" PORTB.5       !!!

    static unsigned char nb=0;    //   
    static unsigned int sum=0;    //   
    static unsigned char fpv=0;
    static unsigned int out=30000;

    // ICR1 (H  L) =  ,      ,
    //    ,      
    ICR1H=(unsigned char)(out>>8);  //  
    ICR1L=(unsigned char)out;

    if (nb<cur_model.num_ch) {
    //    , 
    //         
        out=CHcalc(nb);   //   
        out_ch[nb]=out;   //     .
        sum+=out;         //    
        nb++;             //    
    }
    else { //   , ..   
           //  ,      
           //   .
        out=30000-sum; // 1500,000/30000= 50Hz  //    = - 
        nb=0; sum=0;   //  ,     ...
    }
    if(nb!=1) return;

    //           
    TimerTachometer();
    if(fpv) return;
    fpv=1;
    #asm("sei")
    f_l++;
    Calc();
    TimerOn();
    f_l++;
    fpv=0;
}
//------------------------------------------------------

void WaitKeysUp(void)
{
while(!KEY_LEFT || !KEY_RIGHT || !KEY_UP || !KEY_DOWN) delay_ms(100);
}
//------------------------------------------------------
#ifdef NoCheckThrottleOnStart
#else
void VerReady(void) {

#define LeftTabX 4
#define Down_throttle_Y 15
#define Throttle_percent_Y 35
#define ADCstate_Y 50

    char buff[20];
    signed int v10, v11, v12;
    enum ADCshowState {ADChide, ADCshow} ADCShowMode;

    ADCShowMode=ADChide;
    if ((ADmax[AD_Thrtl]-ADmin[AD_Thrtl]) < 0) {  //     
        v10=ADmax[AD_Thrtl];
        ADmax[AD_Thrtl]=ADmin[AD_Thrtl];
        ADmin[AD_Thrtl]=v10;
    };
    v10=(ADmax[AD_Thrtl]-ADmin[AD_Thrtl])/10;    //10%  
    if (v10==0) v10=1;             //   ADmax[2]=ADmin[2]
    while(1) {
        v12=read_adc(ch_Throttle);
        if(v12>ADmin[AD_Thrtl]) v11=v12-ADmin[AD_Thrtl]; //  
        else break;
        if (v11<v10) break;            //      10%
        else {
            if (!KEY_UP || !KEY_DOWN) { //    <-> 
                WaitKeysUp();
                if (ADCShowMode == ADChide) ADCShowMode = ADCshow;
                else ADCShowMode = ADChide;
            };
            v11=(v11*10)/v10;          //  
            LCD_clear();
            LCD_setxy(LeftTabX,Down_throttle_Y);
            LCD_wrsf("Down throttle!", 1);
            sprintf(buff, "Throttle %i%%", v11);
            LCD_setxy(LeftTabX,Throttle_percent_Y);
            LCD_wrs(buff, 1);
            if (ADCShowMode == ADCshow) {
                sprintf(buff, "ADC=%i min=%i", v12, ADmin[2]);
                LCD_setxy(LeftTabX,ADCstate_Y);
                LCD_wrs(buff, 1);
            };
            LCD_refresh();
            beep_start(error_starting, 3, 0);
            delay_ms(1500);
        };
      };
}
//------------------------------------------------------
#endif

void ResetToDefault (void) //ER
{   unsigned char i, x;
    unsigned int v;

    #define X1i WidthS/10
    #define X2i (WidthS - X1i)
    #define Y1i HeightS/2
    #define Y2i (Y1i + HeightS/4)

    LCD_clear();
    displ_head("Initial"); 
    LCD_rectangle(X1i, Y1i, X2i, Y2i, 1);
    LCD_refresh();
    for(i=0, x=8; i<MAX_MODELS; i++) {
        MODEL_reset(i);
        v=(X2i-X1i)*(unsigned int)i; v/=(MAX_MODELS-1); x=(unsigned char)(X1i+v);
        LCD_fillrect(X1i, Y1i, x, Y2i, 1);
        LCD_refresh();
      };
    EEPR_start_model=0;
    EEPR_f_sound_en=1;
    EEPR_BatCntr[0]=98; EEPR_BatCntr[1]=92; EEPR_BatCntr[2]=110;
    EEPR_AntCntr=10;
    EEPR_FirstON=UNI_KEY;
    SetCRC_EEPROM();
}
//-------------------------------------------------------------

void ResetToDefaultWithAsk (char ResetMSG) {
    LCD_clear();
    switch (ResetMSG) {
    case 1:
        displ_head("DOWN pressed");
    break;
    default:
        displ_head("EEPROM fault"); //""
    };
    #ifndef M_AskSureXY           //     displ.c, .. -
        #define M_AskSureXY
        #define M_AskSureX 2
        #define M_AskSureQuestY 15
    #endif
    LCD_setxy(M_AskSureX,M_AskSureQuestY);
    LCD_wrsf("Factory reset,", 1);
    AreYouSure_LR();
    beep_start(error_sound, 2, 2);
    while(1) {
      WaitKeysUp();
      if(!KEY_LEFT) break;
      if(!KEY_RIGHT) {
          beep_start(hello_sound, 4, 0);
          ResetToDefault();
          break;
      }
    }
    WaitKeysUp();
}
//-------------------------------------------------------------
//   

//  
//   ("")
#define TH HeightS/8            //  
#define TW WidthS/11            //  
#define UpPole TH*1.5           // 
#define LeftPole 0              // 
#define AdjAreaW TW*4           // 
#define AdjBarW TW-1              //   ( TW)
#define IntAdjArea TW           //  
#define IntAdjBar TW            //     
//    
#define Y1 UpPole               //    
#define Y2 Y1+AdjAreaW          //    
#define X1A1 LeftPole           //   
#define X2A1 X1A1+AdjAreaW      //   
#define X1A2 X2A1+IntAdjArea    //   
#define X2A2 X1A2+AdjAreaW      //   
#define X1B X2A2+IntAdjBar      //  
#define X2B X1B+AdjBarW         //  

//  
#define YC0 11 // 
#define YCS 11 //  
#define XC0  0 //    ,  
#define XCu 14 //    
#define NoCalibChar 0x2d       // , "-" (dec. 45)
#define CalibNoCenterChar 0x2B //,    , "+" (dec. 43)
#define CalibCenterChar 61     //   , "=" (dec. 61)


unsigned char GetCanCalibrStatus(unsigned char j, signed int ADcurr, unsigned char RetType) {
// RetType=1,    ,  -  
    signed int v11, v12, v13;

    if(ADmax[j]-ADmin[j]<512) {                     // ,
        if (RetType) return(0);                     // . , =0
        else return(NoCalibChar);                   // . , "-"
    }
    else {
        v11=(ADmax[j]-ADmin[j])/2;                  //   
        v12=v11/10;                                 // 5%  
        v13=ADcurr-ADmin[j];                        //     
        if (v13>(v11-v12) && v13<(v11+v12)) {       //      10% (  -5%..+5%)
            if (RetType) return(2);                 // . , =2
            else return(CalibCenterChar);           // . , "="
        }
        else {                                      // ,    ,
            if (RetType) return(1);                 // . , =1
            else return(CalibNoCenterChar);         // . , "+"
        };
    };
}

void JoyAreaDraw (unsigned char HorzId, unsigned char VertId, unsigned char XLt, unsigned char YUp, unsigned char XRt, unsigned char YDn) {
    unsigned char x, y, CalHorzStat, CalVertStat;
    unsigned long v;

    CalHorzStat=GetCanCalibrStatus(HorzId, ADcur[HorzId],1);
    CalVertStat=GetCanCalibrStatus(VertId, ADcur[VertId],1);

    if(CalHorzStat>0) {                         // .   
        LCD_line(XLt, YUp, XRt, YUp, 1);        //   
        LCD_line(XLt, YDn, XRt, YDn, 1);
    }
    else {                                      // .    
        LCD_dashline(XLt, YUp, XRt, YUp);       //   
        LCD_dashline(XLt, YDn, XRt, YDn);
    };
    if(CalVertStat>0) {                         // .   
        LCD_line(XLt, YUp, XLt, YDn, 1);        //   
        LCD_line(XRt, YUp, XRt, YDn, 1);
    }
    else {                                      // .   
        LCD_dashline(XLt, YUp, XLt, YDn);       //   
        LCD_dashline(XRt, YUp, XRt, YDn);
    };

    v=ADcur[HorzId]-ADmin[HorzId];
    v*=XRt-XLt-2;
    v/=(ADmax[HorzId]-ADmin[HorzId]);
    x=XLt+1+v;                                  //   

    v=ADcur[VertId]-ADmin[VertId];
    v*=YDn-YUp-2;
    v/=(ADmax[VertId]-ADmin[VertId]);
    y=YDn-1-v;                                  //   

    LCD_pixel(x, y-2,1);                        //  
    LCD_line(x-1, y-1, x+1, y-1,1);             // 
    LCD_line(x-2, y, x+2, y,1);
    LCD_line(x-1, y+1, x+1, y+1,1);
    LCD_pixel(x, y+2,1);

    if (CalHorzStat + CalVertStat>3) {          //      10%   
        LCD_rectangle(x-3, y-3, x+3, y+3, 1);   //  
    };
}

void calibr (void) {

#define WrongX  8
#define WrongY 10
#define NotCentredX 2
#define NotCentredStepY 9
#define AdPropShowAs 8    //  ,  !  ID  AddProp

    unsigned char i, x, y, CurrChar;
    char buff[16];
    enum CalScrRegs {graph, text} CalScrMode;

    CalScrMode = graph;
    beep_start(calibr_sound, 3, 0);
    delay_ms(10);

    ADcur[AD_Ail]=read_adc(ch_Ailerons);
    ADcur[AD_Elev]=read_adc(ch_Elevator);
    ADcur[AD_Thrtl]=read_adc(ch_Throttle);
    ADcur[AD_Rud]=read_adc(ch_Rudder);
    ADcur[AD_AdRpop]=read_adc(ch_Rpop_contr);
    ADcur[AD_Ghost]=512;                       //  - " "  .
    ADmid[AD_Ghost]=512;                       //  
    ADmin[AD_Ghost]=0;
    ADmax[AD_Ghost]=1023;

    for (i=0; i<5; i++) { ADmin[i]=ADcur[i]; ADmax[i]=ADcur[i]; }
    f_sound_en=1;

    while (KEY_RIGHT && KEY_LEFT) {
        LCD_clear();
        displ_head("Calibration");
        ADcur[AD_Ail]=read_adc(ch_Ailerons);
        ADcur[AD_Elev]=read_adc(ch_Elevator);
        ADcur[AD_Thrtl]=read_adc(ch_Throttle);
        ADcur[AD_Rud]=read_adc(ch_Rudder);
        ADcur[AD_AdRpop]=read_adc(ch_Rpop_contr);

        for (i=0; i<5; i++) {
            if (ADmin[i]>ADcur[i]) ADmin[i]=ADcur[i];
            if (ADmax[i]<ADcur[i]) ADmax[i]=ADcur[i];
        };

        if (!KEY_UP || !KEY_DOWN) { //    <-> 
            WaitKeysUp();
            if (CalScrMode == graph) CalScrMode = text;
            else CalScrMode = graph;
        };
        if (CalScrMode == graph) { //  
            JoyAreaDraw(AD_Rud, AD_Thrtl, X1A1, Y1, X2A1, Y2);  //  
            JoyAreaDraw(AD_Ail, AD_Elev, X1A2, Y1, X2A2, Y2);   //  
            JoyAreaDraw(AD_Ghost, AD_AdRpop, X1B, Y1, X2B, Y2); // .  (   TIC54   )
        }
        else { //  
            for (i=0, y=YC0, CurrChar=0x31; i<6; i++, y=y+YCS, CurrChar++) {   //"0x31" <=> "1"
                if (CurrChar==0x35) CurrChar=0x38;                             // "5"  "8"
                LCD_setxy(XC0,y);
                LCD_char(CurrChar,1);
                LCD_char(GetCanCalibrStatus(i, ADcur[i], 0),1);
                sprintf(buff, " %4u %4u %4u", ADcur[i], ADmin[i], ADmax[i]);
                LCD_setxy(XCu,y);
                LCD_wrs(buff, 1);
            };
        };
        LCD_refresh();
    };

    if(!KEY_LEFT) return;
    ADmid[AD_Ail]=read_adc(ch_Ailerons);
    ADmid[AD_Elev]=read_adc(ch_Elevator);
    ADmid[AD_Thrtl]=read_adc(ch_Throttle);
    ADmid[AD_Rud]=read_adc(ch_Rudder);
    ADmid[AD_AdRpop]=read_adc(ch_Rpop_contr);
    for (i=0; i<5; i++) {                //  ?
        EEPR_ADmin[i]=ADmin[i];
        EEPR_ADmid[i]=ADmid[i];
        EEPR_ADmax[i]=ADmax[i];
    };

    //   :
    LCD_clear();
    displ_head("Calibration");
    y=WrongY;
    LCD_setxy(WrongX,y);
    LCD_wrsf("Wrong! Errors:", 1);

    for (i=0, x=0; i<5; i++) {   //      
        if ( GetCanCalibrStatus(i, ADmid[i], 1) < 2) {
            x=1;                                        //      
            if (i==AD_AdRpop) i=AdPropShowAs-1;
            y=y+NotCentredStepY;
            LCD_setxy(NotCentredX,y);
            sprintf(buff, "ch%i not centred",i+1);
            LCD_wrs(buff, 1);
        };
    };
    if(x) {
        LCD_refresh();
        beep_start(error_sound, 2, 0);
        delay_ms(3000);
        EEPR_Calibration=0;
    }
    else {
        //LCD_clear();            //  = calibr_thermometer,   LCD_clear();
        EEPR_Calibration=UNI_KEY;
    };
    SetCRC_EEPROM();
}
//-------------------------------------------------------------

void calibr_thermometer (void) {
    signed int t;
    unsigned int AD;
    char buff[20];
    bit f;

    t=25; f=0;
    while(KEY_RIGHT && KEY_LEFT) {
        if(!KEY_UP || !KEY_DOWN) {
            beep_start(key_sound, 1, 0);
            if(!KEY_UP && t<100) t++;
            if(!KEY_DOWN && t>-25) t--;
            f=1;
        };
        LCD_clear();
        displ_head("Thermometer");
        sprintf(buff, "Set curr t%cC: %d", 132, t);
        LCD_setxy(2,11); LCD_wrs(buff, 1);
        AD=read_adc(ch_Temperature);
        sprintf(buff, "%u", AD);
        LCD_setxy(2,28); LCD_wrs(buff, 1);
        LCD_refresh();
        if(f) { f=0; while(!KEY_UP || !KEY_DOWN) delay_ms(100); }
    }
    if(!KEY_LEFT) return;
    EPPR_CalibrTemperature[0]=50+t;
    EPPR_CalibrTemperature[1]=AD;
    SetCRC_EEPROM();
}
//----------------------------------------------------------------------------------------------------

void main(void)
{
unsigned char i;

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P
PORTA=0xFF;
DDRA=0x00;
// Port B initialization
// Func7=Out Func6=In Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=Out
// State7=0 State6=T State5=0 State4=T State3=T State2=0 State1=0 State0=T
PORTB=0x01;
DDRB=0xA7;
// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
PORTC=0x0F;
DDRC=0xF0;
// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T
PORTD=0xF0;
DDRD=0x00;
// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In
// State7=P State6=P State5=P State4=P State3=0 State2=P State1=P State0=P
PORTE=0xF7;
DDRE=0x08;
// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTF=0x00;
DDRF=0x00;
// Port G initialization
// Func4=Out Func3=Out Func2=Out Func1=In Func0=In
// State4=0 State3=0 State2=0 State1=T State0=T
PORTG=0x00;
DDRG=0x1C;
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1500,000 kHz
// Mode: Fast PWM top=ICR1
// OC1A output: Non-Inv.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x82;
TCCR1B=0x1A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x17;
ICR1L=0x70;
OCR1AH=0x02;
OCR1AL=0x68;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: 1500,000 kHz
// Mode: CTC top=ICR3
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Toggle
// OC3B output: Discon.
// OC3C output: Discon.
// Timer 3 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x40;
TCCR3B=0x18; //off
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x02;
EICRB=0x00;
EIMSK=0x0;
EIFR=0x01;
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;
ETIMSK=0x10;
// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
// ADC initialization
// ADC Clock frequency: 187,500 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x86;
// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*3000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;

#asm("sei")

    LCD_init();
    LCD_clear();
    #ifdef SE_Joy //    " "  
        //  -   KEY_DOWN
        #define KeyAskResetCondition (EEPR_FirstON!=UNI_KEY || (!KEY_DOWN))
    #else
        // => KeyLeft + KeyRight
        #define KeyAskResetCondition (EEPR_FirstON!=UNI_KEY || (!KEY_LEFT && !KEY_RIGHT)) //ResetToDefaultWithAsk(1); //KeyDown error MSG
    #endif
    if (KeyAskResetCondition) ResetToDefaultWithAsk(1);  //     ( "")
    if (VerifyCRC_EEPROM()  ) ResetToDefaultWithAsk(0);  //     EEPROM
    if (EEPR_Calibration!=UNI_KEY || !KEY_LEFT) { //   (  "")
      WaitKeysUp();
      calibr();
      WaitKeysUp();
      calibr_thermometer();
    }
    WaitKeysUp();
    g_MainMenuMode=0;
    for(i=0; i<3; i++) g_pos_d[i]=0;
    TX_init();
    #ifdef NoCheckThrottleOnStart
    #else
        VerReady();
    #endif
    g_keys=ReadKeys();
    if(!MODE_KEY2) cur_mode_ind=0;
    else if(!MODE_KEY1) cur_mode_ind=2;
    else cur_mode_ind=1;
    cur_Batt=read_adc(ch_Batt);

    #ifdef AntennaCtrlUse
        cur_Antenna=read_adc(ch_Antenna);
    #endif
    cur_Temperature=read_adc(ch_Temperature);
    Calc();  // c;
    beep_start(hello_sound, 4, 0);
    displ_menu();
    delay_ms(500);
    TIMSK|=0x10; //   

    while (1)
      {
      displ_menu();
      }
    }



