#include <mega128.h>
#include <delay.h>
#include "LMX2306.h"
//-------------------------------------------------------------

#ifdef AntennaCtrlUse
void PLL_send(unsigned long data, unsigned char cn)
{
unsigned long m;

m=1; m<<=cn-1;
while(m)
  {
  if(data & m) PLL_DATA1; else PLL_DATA0;
//  delay_ms(1);
  PLL_CLOCK1;
//  delay_ms(1);
  PLL_CLOCK0;
  m>>=1;
  }
PLL_LE=1;
delay_ms(1);
PLL_LE=0;
}
//-------------------------------------------------------------
void PLL_SetFreq(unsigned char num_freq)
{
unsigned long data;
unsigned int k;
unsigned char sr;

sr=SREG;
#asm("cli")
//if(num_freq>=PLL_CountChannel) return; //  ...
// F_Reg
PLL_send(0xd2L, 21);
// R_Reg
data=PLL_FreqOSC; data/=PLL_FreqStep; data<<=2;
PLL_send(data, 21);
// N_Reg
k=num_freq; k*=PLL_FreqStep; k+=PLL_FreqBand; // freq
k/=PLL_FreqStep;
data=(k>>3); // Bcount
data<<=5;
data|=(k & 0x7); // Acount
data<<=2; 
data|=0x1;
PLL_send(data, 21);
SREG=sr;
}
//-------------------------------------------------------------

unsigned int PLL_GetFreq(unsigned char num_freq)
{
unsigned int ret;
ret=num_freq; ret*=PLL_FreqStep; ret+=PLL_FreqBand;
return ret;
}
//-------------------------------------------------------------
#endif
